package smartHomeApp;

public aspect SmartHomeController {
	pointcut delayTiltIn() : call (void tiltIn(..));
	before(): delayTiltIn() {
		System.out.print("Window is about to tiltIn.. ");		
		if (TemperatureFeature.openUntil > 0) {
			System.out.print("tiltin should not succeed.. so ");	
			if (ProblemWorldDomains.rp.Options == 1)	{
				try {
					System.out.print(Thread.currentThread().getName() + " will sleep for" + (TemperatureFeature.openUntil - System.currentTimeMillis()));	
			        Thread.sleep(TemperatureFeature.openUntil - System.currentTimeMillis());
			    } catch (InterruptedException e) {
			        //We've been interrupted: no more messages.
			        return;
			    }
			}
			
		}
	}
	
	pointcut delayTiltOut() : call (void tiltOut(..));
	before(): delayTiltOut() {
		System.out.print("Window is about to tiltOut.. ");	
		if (SecurityFeature.shutUntil > 0) {
			System.out.print("tiltout should not succeed.. so ");	
			if (ProblemWorldDomains.rp.Options == 1)	{
				try {
					System.out.println(Thread.currentThread().getName() + " will sleep for" + (SecurityFeature.shutUntil - System.currentTimeMillis()));	
			        Thread.sleep(SecurityFeature.shutUntil - System.currentTimeMillis());
			    } catch (InterruptedException e) {
			        //We've been interrupted: no more messages.
			        return;
			    }
			}			
		}
	}		
}
